diff --git a/sys/bus/u4b/input/atp.c b/sys/bus/u4b/input/atp.c
index de02b38151..b456bf97f1 100644
--- a/sys/bus/u4b/input/atp.c
+++ b/sys/bus/u4b/input/atp.c
@@ -1084,108 +1590,135 @@ atp_update_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
 #endif /* USB_DEBUG */
 		if ((n_xpspans == 1) && (n_ypspans == 1))
 			/* The common case of a single pair of new pspans. */
-			atp_add_stroke(sc, &pspans_x[0], &pspans_y[0]);
+			fg_add_stroke(sc, &pspans_x[0], &pspans_y[0]);
 		else
-			atp_add_new_strokes(sc,
-			    pspans_x, n_xpspans,
+			fg_add_new_strokes(sc, pspans_x, n_xpspans,
 			    pspans_y, n_ypspans);
 	}
 
 #ifdef USB_DEBUG
 	if (atp_debug >= ATP_LLEVEL_INFO) {
-		for (i = 0; i < sc->sc_n_strokes; i++) {
-			atp_stroke *stroke = &sc->sc_strokes[i];
-
-			printf(" %s%clc:%u,dm:%d,pnd:%d,cum:%d,max:%d,mv:%d%c"
-			    ",%clc:%u,dm:%d,pnd:%d,cum:%d,max:%d,mv:%d%c",
-			    (stroke->flags & ATSF_ZOMBIE) ? "zomb:" : "",
-			    (stroke->type == ATP_STROKE_TOUCH) ? '[' : '<',
-			    stroke->components[X].loc,
-			    stroke->components[X].delta_mickeys,
-			    stroke->components[X].pending,
-			    stroke->components[X].cum_pressure,
-			    stroke->components[X].max_cum_pressure,
-			    stroke->components[X].movement,
-			    (stroke->type == ATP_STROKE_TOUCH) ? ']' : '>',
-			    (stroke->type == ATP_STROKE_TOUCH) ? '[' : '<',
-			    stroke->components[Y].loc,
-			    stroke->components[Y].delta_mickeys,
-			    stroke->components[Y].pending,
-			    stroke->components[Y].cum_pressure,
-			    stroke->components[Y].max_cum_pressure,
-			    stroke->components[Y].movement,
-			    (stroke->type == ATP_STROKE_TOUCH) ? ']' : '>');
+		TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+			printf(" %s%clc:%u,dm:%d,cum:%d,max:%d,%c"
+			    ",%clc:%u,dm:%d,cum:%d,max:%d,%c",
+			    (strokep->flags & ATSF_ZOMBIE) ? "zomb:" : "",
+			    (strokep->type == ATP_STROKE_TOUCH) ? '[' : '<',
+			    strokep->components[X].loc,
+			    strokep->components[X].delta_mickeys,
+			    strokep->components[X].cum_pressure,
+			    strokep->components[X].max_cum_pressure,
+			    (strokep->type == ATP_STROKE_TOUCH) ? ']' : '>',
+			    (strokep->type == ATP_STROKE_TOUCH) ? '[' : '<',
+			    strokep->components[Y].loc,
+			    strokep->components[Y].delta_mickeys,
+			    strokep->components[Y].cum_pressure,
+			    strokep->components[Y].max_cum_pressure,
+			    (strokep->type == ATP_STROKE_TOUCH) ? ']' : '>');
 		}
-		if (sc->sc_n_strokes)
+		if (TAILQ_FIRST(&sc->sc_stroke_used) != NULL)
 			printf("\n");
 	}
 #endif /* USB_DEBUG */
+	return (movement);
+}
+
+/*
+ * Update strokes by matching against current pressure-spans.
+ * Return true if any movement is detected.
+ */
+static boolean_t
+wsp_update_strokes(struct atp_softc *sc, wsp_finger_t *fingers, u_int n_fingers)
+{
+	boolean_t movement = false;
+	atp_stroke_t *strokep_next;
+	atp_stroke_t *strokep;
+	u_int i;
+
+	if (sc->sc_n_strokes > 0) {
+		movement = wsp_match_strokes_against_fingers(
+		    sc, fingers, n_fingers);
 
+		/* handle zombie strokes */
+		TAILQ_FOREACH_MUTABLE(strokep, &sc->sc_stroke_used, entry, strokep_next) {
+			if (strokep->matched)
+				continue;
+			atp_terminate_stroke(sc, strokep);
+		}
+	}
+
+	/* initialize unmatched fingers as strokes */
+	for (i = 0; i != n_fingers; i++) {
+		if (fingers[i].matched)
+			continue;
+
+		wsp_add_stroke(sc, fingers + i);
+	}
 	return (movement);
 }
 
 /* Initialize a stroke using a pressure-span. */
-static __inline void
-atp_add_stroke(struct atp_softc *sc, const atp_pspan *pspan_x,
-    const atp_pspan *pspan_y)
+static void
+fg_add_stroke(struct atp_softc *sc, const fg_pspan *pspan_x,
+    const fg_pspan *pspan_y)
 {
-	atp_stroke *stroke;
+	atp_stroke_t *strokep;
 
-	if (sc->sc_n_strokes >= ATP_MAX_STROKES)
+	strokep = atp_alloc_stroke(sc);
+	if (strokep == NULL)
 		return;
-	stroke = &sc->sc_strokes[sc->sc_n_strokes];
-
-	memset(stroke, 0, sizeof(atp_stroke));
 
 	/*
 	 * Strokes begin as potential touches. If a stroke survives
 	 * longer than a threshold, or if it records significant
 	 * cumulative movement, then it is considered a 'slide'.
 	 */
-	stroke->type = ATP_STROKE_TOUCH;
-	microtime(&stroke->ctime);
-	stroke->age  = 1;       /* Unit: interrupts */
+	strokep->type    = ATP_STROKE_TOUCH;
+	strokep->matched = false;
+	microtime(&strokep->ctime);
+	strokep->age     = 1;		/* number of interrupts */
+	strokep->x       = pspan_x->loc;
+	strokep->y       = pspan_y->loc;
+
+	strokep->components[X].loc              = pspan_x->loc;
+	strokep->components[X].cum_pressure     = pspan_x->cum;
+	strokep->components[X].max_cum_pressure = pspan_x->cum;
+	strokep->components[X].matched          = true;
+
+	strokep->components[Y].loc              = pspan_y->loc;
+	strokep->components[Y].cum_pressure     = pspan_y->cum;
+	strokep->components[Y].max_cum_pressure = pspan_y->cum;
+	strokep->components[Y].matched          = true;
 
-	stroke->components[X].loc              = pspan_x->loc;
-	stroke->components[X].cum_pressure     = pspan_x->cum;
-	stroke->components[X].max_cum_pressure = pspan_x->cum;
-	stroke->components[X].matched          = TRUE;
-
-	stroke->components[Y].loc              = pspan_y->loc;
-	stroke->components[Y].cum_pressure     = pspan_y->cum;
-	stroke->components[Y].max_cum_pressure = pspan_y->cum;
-	stroke->components[Y].matched          = TRUE;
-
-	sc->sc_n_strokes++;
 	if (sc->sc_n_strokes > 1) {
 		/* Reset double-tap-n-drag if we have more than one strokes. */
 		sc->sc_state &= ~ATP_DOUBLE_TAP_DRAG;
 	}
 
 	DPRINTFN(ATP_LLEVEL_INFO, "[%u,%u], time: %u,%ld\n",
-	    stroke->components[X].loc,
-	    stroke->components[Y].loc,
-	    (unsigned int)stroke->ctime.tv_sec,
-	    (unsigned long int)stroke->ctime.tv_usec);
+	    strokep->components[X].loc,
+	    strokep->components[Y].loc,
+	    (u_int)strokep->ctime.tv_sec,
+	    (unsigned long int)strokep->ctime.tv_usec);
 }
 
 static void
-atp_add_new_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
-    u_int n_xpspans, atp_pspan *pspans_y, u_int n_ypspans)
+fg_add_new_strokes(struct atp_softc *sc, fg_pspan *pspans_x,
+    u_int n_xpspans, fg_pspan *pspans_y, u_int n_ypspans)
 {
-	int       i, j;
-	atp_pspan spans[2][ATP_MAX_PSPANS_PER_AXIS];
-	u_int     nspans[2];
+	fg_pspan spans[2][FG_MAX_PSPANS_PER_AXIS];
+	u_int nspans[2];
+	u_int i;
+	u_int j;
 
 	/* Copy unmatched pspans into the local arrays. */
 	for (i = 0, nspans[X] = 0; i < n_xpspans; i++) {
-		if (pspans_x[i].matched == FALSE) {
+		if (pspans_x[i].matched == false) {
 			spans[X][nspans[X]] = pspans_x[i];
 			nspans[X]++;
 		}
 	}
 	for (j = 0, nspans[Y] = 0; j < n_ypspans; j++) {
-		if (pspans_y[j].matched == FALSE) {
+		if (pspans_y[j].matched == false) {
 			spans[Y][nspans[Y]] = pspans_y[j];
 			nspans[Y]++;
 		}
@@ -1194,7 +1727,7 @@ atp_add_new_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
 	if (nspans[X] == nspans[Y]) {
 		/* Create new strokes from pairs of unmatched pspans */
 		for (i = 0, j = 0; (i < nspans[X]) && (j < nspans[Y]); i++, j++)
-			atp_add_stroke(sc, &spans[X][i], &spans[Y][j]);
+			fg_add_stroke(sc, &spans[X][i], &spans[Y][j]);
 	} else {
 		u_int    cum = 0;
 		atp_axis repeat_axis;      /* axis with multi-pspans */
@@ -1213,7 +1746,7 @@ atp_add_new_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
 		/* Create new strokes from pairs of unmatched pspans */
 		i = 0, j = 0;
 		for (; (i < nspans[X]) && (j < nspans[Y]); i++, j++) {
-			atp_add_stroke(sc, &spans[X][i], &spans[Y][j]);
+			fg_add_stroke(sc, &spans[X][i], &spans[Y][j]);
 
 			/* Take care to repeat at the multi-pspan. */
 			if (repeat_count > 0) {
